%%%-------------------------------------------------------------------
%% @doc erlk top level supervisor.
%% @end
%%%-------------------------------------------------------------------

-module(erlk_sup).

-behaviour(supervisor).

-export([start_link/0]).

-export([init/1]).

-define(SERVER, ?MODULE).

start_link() ->
    supervisor:start_link(?MODULE, []).

%% sup_flags() = #{strategy => strategy(),         % optional
%%                 intensity => non_neg_integer(), % optional
%%                 period => pos_integer()}        % optional
%% child_spec() = #{id => child_id(),       % mandatory
%%                  start => mfargs(),      % mandatory
%%                  restart => restart(),   % optional
%%                  shutdown => shutdown(), % optional
%%                  type => worker(),       % optional
%%                  modules => modules()}   % optional

init(_) ->
    SupFlags = #{strategy => rest_for_one},
    ChildSpecs = [
                  #{id => mqtt,
                    start => {mqtt, start_link, []}
                   },
                  #{id => event_mgr,
                    start => {event_mgr, start_link, [[mqtt, none]]}
                   }
                 ],
    {ok, {SupFlags, ChildSpecs}}.

%% internal functions
